<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>上传处理文件</title>
</head>

<body>
<?php

$gotopage="tu.php";
//var_dump($_FILES["file"]);
//array(5) { ["name"]=> string(17) "56e79ea2e1418.jpg" ["type"]=> string(10) "image/jpeg" ["tmp_name"]=> string(43) "C:\Users\asus\AppData\Local\Temp\phpD07.tmp" ["error"]=> int(0) ["size"]=> int(454445) } 
//1.限制文件的类型，防止注入php或其他文件，提升安全
//2.限制文件的大小，减少内存压力
//3.防止文件名重复，提升用户体验
    //方法一：  修改文件名    一般为:时间戳+随机数+用户名
    // 方法二:建文件夹
    
//4.保存文件

//判断上传的文件是否出错,是的话，返回错误
if($_FILES["file"]["error"])
{
    //echo $_FILES["file"]["error"]; 
	header("refresh:10;url=".$gotopage); 
	print('上传出错，错误代码:'.$_FILES["file"]["error"].'，请稍等...<br>10秒后自动跳转。');
	echo "<br /><br /><br />";
	switch ($_FILES["file"]["error"])
    {
     case 1:
         echo "上传的文件超过了 php.ini 中 upload_max_filesize 选项限制的值。";
         break;  
     case 2:
         echo "上传文件的大小超过了 HTML 表单中 MAX_FILE_SIZE 选项指定";
         break;
     case 3:
         echo "文件只有部分被上传。 ";
         break;
     case 4:
         echo "没有文件被上传。 ";
         break;     
     case 5:
         echo "上传文件的大小超过了 HTML 表单中 MAX_FILE_SIZE 选项指定";
         break; 
     case 6:
         echo "找不到临时文件夹。PHP 4.3.10 和 PHP 5.0.3 引进。";
         break;  
     case 7:
         echo "文件写入失败。PHP 5.1.0 引进。";
         break;  
  
  
   }
	
	echo "<br /><br /><br />
	错误代码解析<br />
	UPLOAD_ERR_OK:其值为 0，没有错误发生，文件上传成功。<br /> 
    UPLOAD_ERR_INI_SIZE: 其值为 1，上传的文件超过了 php.ini 中 upload_max_filesize 选项限制的值。<br /> 
	UPLOAD_ERR_FORM_SIZE:其值为 2，上传文件的大小超过了 HTML 表单中 MAX_FILE_SIZE 选项指定<br />
	UPLOAD_ERR_PARTIAL:其值为 3，文件只有部分被上传。 <br />
	UPLOAD_ERR_EXTENSION:其值为 4，没有文件被上传。 <br />
	UPLOAD_ERR_NO_TMP_DIR: 其值为 6，找不到临时文件夹。PHP 4.3.10 和 PHP 5.0.3 引进。<br /> 
	UPLOAD_ERR_CANT_WRITE:其值为 7，文件写入失败。PHP 5.1.0 引进。<br />
	";
	   
}
else
{

  echo "Upload: " . $_FILES["file"]["name"] . "<br />";
  echo "Type: " . $_FILES["file"]["type"] . "<br />";
  echo "Size: " . ($_FILES["file"]["size"] / 1024) . " Kb<br />";
  echo "Stored in: " . $_FILES["file"]["tmp_name"]. "<br /><br /><br />";
  

    //没有出错
    //加限制条件
    //判断上传文件类型为png或jpg且大小不超过10240000B(10M)
    if(($_FILES["file"]["type"]=="image/png"||$_FILES["file"]["type"]=="image/gif"||$_FILES["file"]["type"]=="image/jpeg")&&$_FILES["file"]["size"]<10240000)
    {
            //防止文件名重复
            $filename ="./img/".time()."_".$_FILES["file"]["name"];
            //转码，把utf-8转成gb2312,返回转换后的字符串， 或者在失败时返回 FALSE。
            $filename =iconv("UTF-8","gb2312",$filename);
             //检查文件或目录是否存在
            if(file_exists($filename))
            {
                echo"该文件已存在";
            }
            else
            {  
                //保存文件,   move_uploaded_file 将上传的文件移动到新位置  
                move_uploaded_file($_FILES["file"]["tmp_name"],$filename);//将临时地址移动到指定地址
				header("refresh:5;url=".$gotopage); print('上传成功，请稍等...<br>五秒后自动跳转。');    
            }        
    }
    else
    {
        //echo"文件类型不对";
		header("refresh:5;url=".$gotopage); print('上传失败，你上传的不是图片，请稍等...<br>五秒后自动跳转。');  
    }
}
?>
</body>
</html>